Subject: Re: [PATCH v2 0/3] Teach fetch and pull to recursively fetch submodules too

From: Jens Lehmann <[email-masked]>
Date: Wed, 13 Oct 2010 22:06:15 +0200

Am 13.10.2010 21:34, schrieb Kevin Ballard:
> On Oct 13, 2010, at 12:32 PM, Jens Lehmann wrote:
> 
>>>> There are use cases like mine where automatic recursion is just the right
>>>> thing to do. But I would be fine with having to turn the recursion on
>>>> explicitly in the configuration if most people think recursion is not a
>>>> desirable default. It would be really nice to hear from other submodule
>>>> users what they think about that ...
>>>
>>> I tend to think that the right default for fetch is to employ the same level
>>> of recursion that was used for the initial clone.  So if the clone was made
>>> with --recursive then fetch should default to using --recursive.
>>
>> That's a very interesting idea.
> 
> I'm not sure it's correct though. For example, with my scenario every single submodule is required for a correct build, but most submodules should definitely not be updated unless their parent submodule updates its gitlink. So --recursive is recommended for `git clone`, but a non-recursive fetch would be the correct behavior going forward.

For *your* use case it might not be correct, but for others it may very
well be.

We need to get more user stories like that to get an overview about what
config options are useful and what might be reasonable defaults for them.
And then we can decide what set of options and defaults to choose.